import { Subject, Observable } from 'rxjs';
import { SelectionBound, SelectionBoundary } from './types';
export declare class JdBucketSelectionDrag {
    constructor();
    static _instance: JdBucketSelectionDrag | null;
    static getInstance(): JdBucketSelectionDrag;
    protected moveX: number;
    protected moveY: number;
    protected subjectBoundary: Subject<SelectionBoundary>;
    protected subjectFlushed: Subject<void>;
    /**
     * document
     * @returns {Document}
     */
    getDocument(): Document;
    /**
     * 터치 분기 처리
     * @protected
     */
    protected touchable(): {
        is: boolean;
        EventType: {
            [key: string]: any;
        };
    };
    /**
     * document mousemove 이벤트 핸들러.
     * @protected
     */
    protected handleSelectionMove: (evt: MouseEvent | TouchEvent) => void;
    /**
     * document mouseup 이벤트 핸들러.
     * @protected
     */
    protected handleSelectionUp: () => void;
    /**
     * document 핸들러 등록
     * @protected
     */
    protected addSelectionHandler(): void;
    /**
     * document 핸들러 제거
     * @protected
     */
    protected removeSelectionHandler(): void;
    /**
     * 옵저버: 바운더리 영역
     * @returns {Observable<SelectionBoundary>}
     */
    observeBoundary(): Observable<SelectionBoundary>;
    /**
     * 옵저버: 바운더리 선택 해제
     * @returns {Observable<void>}
     */
    observeFlushed(): Observable<void>;
    /**
     * 알림: 바운더리 영역 변경.
     * @param {SelectionBoundary} boundary
     */
    dispatchBoundary(boundary: SelectionBoundary): void;
    /**
     * 알림: 바운더리 영역 해제.
     */
    dispatchFlushed(): void;
    /**
     * 바운더리 영역 변경
     */
    updateBoundary(): void;
    /**
     * 셀렉션 시작.
     * @param {SelectionBound} bound
     */
    startSelection(bound: SelectionBound): void;
    /**
     * 셀렉션 종료.
     */
    endSelection(): void;
    /**
     * 셀렉션 해제.
     */
    flushSelection(): void;
    /**
     * 해제.
     */
    dispose(): void;
    /**
     * 파기
     */
    destroy(): void;
}
