import { Subject, Observable } from 'rxjs';
import { SelectionBound, SelectionBoundary } from './types';
export declare class JdBucketSelectionRange {
    constructor();
    static _instance: JdBucketSelectionRange | null;
    static getInstance(): JdBucketSelectionRange;
    protected startX: number;
    protected startY: number;
    protected moveX: number;
    protected moveY: number;
    protected subjectBoundary: Subject<SelectionBoundary>;
    protected subjectFlushed: Subject<SelectionBoundary>;
    protected lastBoundary: SelectionBoundary | null;
    /**
     * document
     * @returns {Document}
     */
    getDocument(): Document;
    /**
     * document mousemove 이벤트 핸들러.
     * @protected
     */
    protected handleSelectionMove: (evt: MouseEvent) => void;
    /**
     * document mouseup 이벤트 핸들러.
     * @protected
     */
    protected handleSelectionUp: () => void;
    /**
     * document 핸들러 등록
     * @protected
     */
    protected addSelectionHandler(): void;
    /**
     * document 핸들러 제거
     * @protected
     */
    protected removeSelectionHandler(): void;
    /**
     * 옵저버: 바운더리 영역
     * @returns {Observable<SelectionBoundary>}
     */
    observeBoundary(): Observable<SelectionBoundary>;
    /**
     * 옵저버: 바운더리 선택 해제
     * @returns {Observable<SelectionBoundary>}
     */
    observeFlushed(): Observable<SelectionBoundary>;
    /**
     * 알림: 바운더리 영역 변경.
     * @param {SelectionBoundary} boundary
     */
    dispatchBoundary(boundary: SelectionBoundary): void;
    /**
     * 알림: 바운더리 영역 해제.
     */
    dispatchFlushed(): void;
    /**
     * 바운더리 영역 변경
     */
    updateBoundary(): void;
    /**
     * 셀렉션 시작.
     * @param {SelectionBound} bound
     */
    startSelection(bound: SelectionBound): void;
    /**
     * 셀렉션 종료.
     */
    endSelection(): void;
    /**
     * 셀렉션 해제.
     */
    flushSelection(): void;
    /**
     * 해제.
     */
    dispose(): void;
    /**
     * 파기
     */
    destroy(): void;
}
