interface IntersectRange {
    start: number;
    end: number;
}
/**
 * uuid 발급
 */
export declare const createUid: () => string;
/**
 * 축 교차점 비교
 * one 의 { start, end } 와 other 의 { start, end } 를 비교
 * @param one {IntersectRange}
 * @param other {IntersectRange}
 */
export declare const intersect: (one: IntersectRange, other: IntersectRange) => {
    start: number;
    end: number;
};
/**
 * intercet 를 이용해 hitTest
 *
 * const A = { x: 0, w: 100, y: 0, h: 20 }
 * const B = { x: 90, w: 100, y: 30, h: 20 }
 * console.log(intercet({ start: A.x, end: A.x + A.w }, { start: B.x, end: B.x + B.w })) // x 축 교차됨
 * console.log(intercet({ start: A.y, end: A.y + A.h }, { start: B.y, end: B.y + B.h })) // y 축 교차하지 않음
 * console.log('A 와 B 는 겹치지 않음')
 * @param one {IntersectRange}
 * @param other {IntersectRange}
 */
export declare const isIntersect: (one: IntersectRange, other: IntersectRange) => boolean;
/**
 * touch 환경인지 여부
 */
export declare const isTouchable: () => boolean;
/**
 * MouseEvent, TouchEvent 의 absolute x, y 반환
 */
export declare const getTouchPosition: (evt: MouseEvent | TouchEvent) => {
    x: number;
    y: number;
} | null;
export {};
